package cn.com.infosec.mobile.android.net;

import android.support.annotation.Keep;
import android.support.annotation.NonNull;
import cn.com.infosec.mobile.android.IMSSdk;
import cn.com.infosec.mobile.android.Jointer;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.Arrays;
import java.util.logging.Level;

/** @deprecated */
@Deprecated
@Keep
public class InfosecSocket extends Socket implements InfosecSSLOption {
   private static final int ISECE_SUCCESS = 0;
   private static final int ISECE_ERROR_UNKNOWN = 1;
   private static final int ISECE_INVALID_PARAM = 2;
   private static final int ISECE_FAILED_INIT = 3;
   private static final int ISECE_FAILED_RANDOM = 4;
   private static final int ISECE_FAILED_CERTINFO = 5;
   private static final int ISECE_NULL_CERT = 6;
   private static final int ISECE_INVALID_KEY = 7;
   private static final int ISECE_ERROR_PUBKEY = 8;
   private static final int ISECE_BASE_DECODE = 9;
   private static final int ISECE_BASE_ENCODE = 10;
   private static final int ISECE_PUBKEY_DIFFERENT = 11;
   private static final int ISECE_ERROR_GEN_KEYPAIR = 12;
   private static final int ISECE_ERROR_ENCRYPT = 13;
   private static final int ISECE_ERROR_DECRYPT = 14;
   private static final int ISECE_ERROR_VERIFY_PIN = 15;
   private static final int ISECE_ERROR_SIGN = 16;
   private static final int ISECE_ERROR_DATABASE = 17;
   private static final int ISECE_INVALID_HASH = 18;
   private static final int ISECE_ERROR_GEN_P10 = 19;
   private static final int ISECE_BUFFER_TOO_SMALL = 20;
   private static final int ISECE_NEW_CERT_UPDATE = 21;
   private static final int ISECE_ERROR_KEY_EXIST = 22;
   private static final int ISECE_INVALID_SIGN_CERT = 23;
   private static final int ISECE_INVALID_ENC_CERT = 24;
   private static final int ISECE_INVALID_BASE64 = 25;
   private static final int ISECE_INVALID_ASN1 = 26;
   private static final int ISECE_UNSUPPORT = 27;
   private static final int ISECE_SIGN_NO_PLAIN = 28;
   private static final int ISECE_SIGN_VERIFY_SM2 = 29;
   private static final int ISECE_SIGN_VERIFY_RSA = 30;
   private static final int ISECE_ERROR_MEMORY = 31;
   private static final int ISECE_INVALID_SOCKET = 32;
   private static final int ISECE_ERROR_SSL_ROOT = 33;
   private static final int ISECE_ERROR_HANDLE = 34;
   private static final int ISECE_ERROR_SSL = 35;
   private static final int ISECE_ERROR_WANT_READ = 36;
   private static final int ISECE_ERROR_WANT_WRITE = 37;
   private static final int ISECE_ERROR_WANT_X509_LOOKUP = 38;
   private static final int ISECE_ERROR_WANT_SYSCALL = 39;
   private static final int ISECE_ERROR_ZERO_RETURN = 40;
   private InfosecSocketParam socketParam;
   private InfosecSocketRequest socketRequest;
   private long mSSLContext;
   private Jointer jointer;
   private boolean connected;

   public InfosecSocket() {
      Jointer var1;
      if (IMSSdk.isCollaborative()) {
         var1 = new Jointer.<init>();
      } else {
         var1 = null;
      }

      InfosecSocket var10000 = this;
      InfosecSocket var10001 = this;
      this.jointer = var1;
      InfosecSocketParam var2;
      var2 = new InfosecSocketParam.<init>();
      var10001.socketParam = var2;
      InfosecSocketRequest var3;
      var3 = new InfosecSocketRequest.<init>();
      var10000.socketRequest = var3;
   }

   public InfosecSocket(String host, int port) {
      this();
      this.socketParam.setHostIP(host);
      this.socketParam.setHostPort(port);
   }

   public boolean connect(String host, int port, int timeout) {
      this.socketParam.setHostIP(host);
      this.socketParam.setHostPort(port);
      this.setSoTimeout(timeout);
      return this.connect();
   }

   public boolean connect() {
      InfosecSocketParam var1 = this.socketParam;
      long var3;
      this.mSSLContext = var3 = this.socketRequest.initSSLClientNative(var1, this.jointer);
      if (0L == var3) {
         IMSSdk.mLogger.log(Level.SEVERE, "初始化SSL句柄失败:".concat(String.valueOf(this.socketRequest.errNo)));
         this.connected = false;
         return false;
      } else {
         InfosecSocketRequest var10000 = this.socketRequest;
         long var10001 = var3;
         String var4 = this.socketParam.getHostIP();
         if (var10000.connectWithIPNative(var10001, var4, this.socketParam.getHostPort()) != 0) {
            IMSSdk.mLogger.log(Level.SEVERE, "Socket连接失败:".concat(String.valueOf(this.socketRequest.errNo)));
            this.connected = false;
            return false;
         } else {
            this.connected = true;
            return true;
         }
      }
   }

   public boolean isConnected() {
      return this.connected;
   }

   public void close() {
      this.socketRequest.releaseSSLNative(this.mSSLContext);
   }

   public InputStream getInputStream() {
      if (this.connected && this.mSSLContext != 0L) {
         return new InfosecSSLInputStream();
      } else {
         throw new IllegalStateException("Cannot get InputStream when there is no connection or connection fails");
      }
   }

   public OutputStream getOutputStream() {
      if (this.connected && this.mSSLContext != 0L) {
         return new InfosecSSLOutputStream();
      } else {
         throw new IllegalStateException("Cannot get OutputStream when there is no connection or connection fails");
      }
   }

   public synchronized void setSoTimeout(int timeout) {
      if (!this.connected) {
         if (timeout >= 0) {
            InfosecSocket var10000 = this;
            int var2;
            this.socketParam.setConnectTimeout(var2 = timeout / 1000);
            var10000.socketParam.setResponseTimeout(var2);
         } else {
            throw new IllegalArgumentException("timeout can't be negative");
         }
      } else {
         throw new IllegalStateException("Cannot set timeout after connection is set");
      }
   }

   public void setTrustCert(@NonNull String trustCert) {
      if (!this.connected) {
         this.socketParam.setCaFile(new String[]{trustCert});
      } else {
         throw new IllegalStateException("Cannot set trustCert after connection is set");
      }
   }

   public String getTrustCert() {
      return this.socketParam.getCaFile()[0];
   }

   public void setClientCert(@NonNull String signCert, @NonNull String signKey, String encCert, String encKey, String keyPass) {
      if (!this.connected) {
         this.socketParam.setSignCert(signCert);
         this.socketParam.setSignKey(signKey);
         this.socketParam.setEncCert(encCert);
         this.socketParam.setEncKey(encKey);
         this.socketParam.setSslPasswd(keyPass);
      } else {
         throw new IllegalStateException("Cannot set clientCert after connection is set");
      }
   }

   public void setClientCert(@NonNull String userName, @NonNull String certPIN) {
      if (!this.connected) {
         if (IMSSdk.isCollaborative()) {
            this.jointer.setUser(userName);
         }

         this.socketParam.setCertAlias(userName);
         this.socketParam.setCertPIN(certPIN);
      } else {
         throw new IllegalStateException("Cannot set clientCert after connection is set");
      }
   }

   private final class InfosecSSLInputStream extends InputStream {
      private InfosecSSLInputStream() {
      }

      // $FF: synthetic method
      InfosecSSLInputStream(Object x1) {
         this();
      }

      public int read() {
         byte[] var1;
         for(var1 = InfosecSocket.this.socketRequest.readSSLDataNative(InfosecSocket.this.mSSLContext, 1L); 36 == InfosecSocket.this.socketRequest.errNo; var1 = InfosecSocket.this.socketRequest.readSSLDataNative(InfosecSocket.this.mSSLContext, 1L)) {
         }

         return var1 != null && var1.length > 0 ? var1[0] : -1;
      }

      public int read(@NonNull byte[] b) {
         if (b.length == 0) {
            return b.length;
         } else {
            int var2 = 0;
            byte[] var3 = InfosecSocket.this.socketRequest.readSSLDataNative(InfosecSocket.this.mSSLContext, (long)b.length);

            while(true) {
               byte[] var10000;
               byte[] var10001;
               int var4;
               int var7;
               for(; (var4 = InfosecSocket.this.socketRequest.errNo) != 0; var3 = InfosecSocket.this.socketRequest.readSSLDataNative(InfosecSocket.this.mSSLContext, (long)b.length)) {
                  if (var4 != 36 && var4 != 39) {
                     throw new IOException("read Data Failed, C/C++ retCode ".concat(String.valueOf(InfosecSocket.this.socketRequest.errNo)));
                  }

                  if (var3 != null) {
                     var10000 = var3;
                     var10001 = var3;
                     var7 = var3.length;
                     System.arraycopy(var10001, 0, b, 0, var7);
                     var2 += var10000.length;
                  }
               }

               if (var3 != null) {
                  var10000 = var3;
                  var10001 = var3;
                  var7 = var3.length;
                  System.arraycopy(var10001, 0, b, 0, var7);
                  var2 += var10000.length;
               }

               if (var2 >= b.length || (var7 = InfosecSocket.this.socketRequest.sslPendingNative(InfosecSocket.this.mSSLContext)) <= 0) {
                  return var2;
               }

               var4 = b.length - var2;
               InfosecSocketRequest var9 = InfosecSocket.this.socketRequest;
               int var10 = var7;
               long var8 = InfosecSocket.this.mSSLContext;
               long var5 = (long)Math.max(var10, var4);
               var3 = var9.readSSLDataNative(var8, var5);
            }
         }
      }

      public int read(@NonNull byte[] b, int off, int len) {
         if (off >= 0 && len >= 0 && len <= b.length - off) {
            if (len == 0) {
               return 0;
            } else {
               byte[] var4;
               int var10000 = len = this.read(var4 = new byte[len]);
               System.arraycopy(var4, 0, b, off, len);
               return var10000;
            }
         } else {
            throw new IndexOutOfBoundsException();
         }
      }
   }

   private final class InfosecSSLOutputStream extends OutputStream {
      private InfosecSSLOutputStream() {
      }

      // $FF: synthetic method
      InfosecSSLOutputStream(Object x1) {
         this();
      }

      public void write(int b) {
         InfosecSSLOutputStream var10000 = this;
         byte[] var2;
         (var2 = new byte[1])[0] = (byte)b;
         var10000.write(var2);
      }

      public void write(@NonNull byte[] b) {
         InfosecSSLOutputStream var10000 = this;
         int var2 = b.length;
         var10000.write(b, 0, var2);
      }

      public void write(@NonNull byte[] b, int off, int len) {
         int var4;
         if (off >= 0 && off <= b.length && len >= 0 && (var4 = off + len) <= b.length && var4 >= 0) {
            if (len != 0) {
               System.arraycopy(b, off, b = new byte[len], 0, len);
               off = InfosecSocket.this.socketRequest.writeSSLDataNative(InfosecSocket.this.mSSLContext, b);

               while((len = InfosecSocket.this.socketRequest.errNo) != 0) {
                  if (len != 39 && len != 36) {
                     if (len != 37) {
                        throw new IOException("Write Data Failed, C/C++ retCode ".concat(String.valueOf(InfosecSocket.this.socketRequest.errNo)));
                     }

                     b = Arrays.copyOfRange(b, off, b.length - 1);
                     InfosecSocket.this.socketRequest.writeSSLDataNative(InfosecSocket.this.mSSLContext, b);
                  }
               }

            }
         } else {
            throw new IndexOutOfBoundsException();
         }
      }
   }
}
